/*

ti pa
00.00 = void
01.03 = sky

24.03 25.03 26.03 27.03
2C.03 33.03 33.03 2F.03
34.03 33.03 33.03 37.03
3C.03 3D.03 EE.03 3F.03 = big ball

38.03 39.03 = big branch

2D.03 2E.03
35.03 36.03 = small ball

3A.03 3B.03 = small branch

61.00 = horizontal pipe
60.01 = pipe left edge
62.01 = pipe right edge

2B.02 = inside background
23.02 = inside shadow

68.00 {69.00} 6A.00
70.00 {71.00} 72.00 = pillar

83.00 = ladder

C4.01 = spike up

51.00 52.00 53.00 = wily ornament
10.00 = wily door



*/
static void BombmanAscii(Screen& s)
{
    for(unsigned y=0; y<16; ++y)
        for(unsigned x=0; x<16; ++x)
        {
            unsigned char c = s.outmap[y*16+x].tile;
            unsigned char p = s.outmap[y*16+x].palette;
            
            char ch = '?';
            /* Classify types.
             *
             *
             *
             */
            switch(c)
            {
                // sky:
                case 0x01: // sky
                case 0x24 ... 0x27:
                case 0x2C: case 0x33: case 0x2F:
                case 0x34: case 0x37:
                case 0x3C ... 0x3F: // big tree
                case 0x38 ... 0x39: // big branch
                case 0x2D ... 0x2E:
                case 0x35 ... 0x36: // small tree
                case 0x3A ... 0x3B: // small branch
                case 0x00: // void
                    ch = '.';
                    break;
                
                case 0x60 ... 0x62:
                case 0x68 ... 0x6A:
                case 0x70 ... 0x72:
                case 0x51 ... 0x53:
                    ch = '#';
                    break;
                case 0x23: case 0x2B:
                    ch = ' '; // inside
                    break;
                case 0x83:
                    ch = Ascii_Ladder;
                    break;
                case 0xC4:
                    ch = Ascii_Spike;
                    break;
                    
                case 0x10:
                    ch = Ascii_WilyDoor;
                    break;
                
                // There are no gutsblocks in Bombman level.
            }
            
            s.ascii[y*32+x] = ch;
            s.ascii[y*32+x+16] = ' ';
            //printf("%02X",c);      
        }
}

#define BombmanChar  DummyChar

static Level Bombman =
{
    2, // level number.
    "Bombman",

    // screens:
    {
        {
        "################"
        "################"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "################"
        "################"
        "################"
        "################"
        "################"
        "################"
        ,End}
    },

    // actives
    {
    },

    // enemies
    {
    },
    
    // palette
    {
        0x0F, 0x20, 0x00, 0x02, 
        0x0F, 0x2B, 0x19, 0x2C, 
        0x0F, 0x17, 0x07, 0x0F, 
        0x0F, 0x20, 0x00, 0x26, 
        
        0x0F, 0x2C, 0x11, 0x0F, 
        0x0F, 0x20, 0x38, 0x0F, 
        0x0F, 0x27, 0x15, 0x0F, 
        0x0F, 0x30, 0x11, 0x0F, 
        
        0x0F, 0x20, 0x00, 0x02, 
        0x0F, 0x00, 0x10, 0x20, 
        0x0F, 0x17, 0x07, 0x07, 
        0x0F, 0x20, 0x00, 0x26, 
    },

    BombmanAscii,
    BombmanChar
};
