/*

ti pa

01.02 = sky
00.00 = shadow

48.01 {49.01} 4A.01
50.01 {51.01} 52.02 = block type 1

08.01 {09.01} 0A.01
10.01 {11.01} 12.01 = false block

4E.01 = platform
61.02 = / edge (bottomside)
60.02 = \ edge (bottomside)
62.02 = / edge (topside)

17.03 = inside background
16.03 = inside shadow

23.02 24.02
23.02 24.02 = window

C4.02 = spike up


85.00 = ladder

25.03 = boss bg type 1
26.03 = boss bg type 2
27.03 = boss bg type 3


*/
static void Wily2Ascii(Screen& s)
{
    for(unsigned y=0; y<16; ++y)
        for(unsigned x=0; x<16; ++x)
        {
            unsigned char c = s.outmap[y*16+x].tile;
            unsigned char p = s.outmap[y*16+x].palette;
            
            char ch = '?';
            /* Classify types.
             *
             *
             *
             */
            switch(c)
            {
                // air:
                case 0x01:
                    ch = '.';
                    break;
                case 0x00:
                    ch = ',';
                    break;

                case 0x16:
                case 0x17: // inside
                case 0x23: case 0x24: // window
                    ch = ' ';
                    break;
              
                case 0x48 ... 0x4A:
                case 0x50 ... 0x52: // block 1
                case 0x60: // edge
                case 0x61: // edge
                case 0x62: // edge
                case 0x4E: // floor
                    ch = '#';
                    break;
               
                case 0x08 ... 0x0A:
                case 0x10 ... 0x12: // false floor
                    ch = '&';
                    break;

                case 0xC4: //up spike
                    ch = Ascii_Spike;
                    break;
                case 0x85:
                    ch = Ascii_Ladder;
                    break;

                case 0x25:
                case 0x26:
                case 0x27: // boss bg
                    ch = 'X';
                    break;
            }
            
            s.ascii[y*32+x] = ch;
            s.ascii[y*32+x+16] = ' ';
            //printf("%02X",c);
        }
}
#define Wily2Char  DummyChar

static Level Wily2 =
{
    7, // level number.
    "Wily2",

    // screens:
    {
        {
        "################"
        "################"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "################"
        "################"
        "################"
        "################"
        "################"
        "################"
        ,End},
        {"",Last}
    },

    // actives
    {
    },

    // enemies
    {
    },
    
    // palette
    {
        0x0F, 0x20, 0x00, 0x02, 
        0x0F, 0x2B, 0x19, 0x2C, 
        0x0F, 0x17, 0x07, 0x0F, 
        0x0F, 0x20, 0x00, 0x26, 
        
        0x0F, 0x2C, 0x11, 0x0F, 
        0x0F, 0x20, 0x38, 0x0F, 
        0x0F, 0x27, 0x15, 0x0F, 
        0x0F, 0x30, 0x11, 0x0F, 
        
        0x0F, 0x20, 0x00, 0x02, 
        0x0F, 0x00, 0x10, 0x20, 
        0x0F, 0x17, 0x07, 0x07, 
        0x0F, 0x20, 0x00, 0x26, 
    },

    Wily2Ascii,
    Wily2Char
};
