/*

ti pa

60.03 = ground
61.00 = horizontal edge
69.00 = junction
68.00 = vertical edge


2E.01 = horizontal background
2B.01 = vertical background
2F.01 = horizontal bottom

2D.01 = horizontal shadow
22.01 = vertical topleft shadow
23.01 = vertical top shadow
24.01 = vertical topright shadow
2A.01 = vertical leftside shadow
2C.01 = vertical right edge

Use palette 02 = blue

00.00 = void

*/
static void Wily3Ascii(Screen& s)
{
    for(unsigned y=0; y<16; ++y)
        for(unsigned x=0; x<16; ++x)
        {
            unsigned char c = s.outmap[y*16+x].tile;
            unsigned char p = s.outmap[y*16+x].palette;
            
            char ch = '?';
            /* Classify types.
             *
             *
             *
             */
            switch(c)
            {
                // air:
                case 0x00:
                    ch = '.';
                    break;
                case 0x60:
                case 0x68:
                case 0x69:
                case 0x61:
                    ch = '#';
                    break;
                case 0x2E:
                case 0x2F:
                case 0x2D:
                    ch = p==1 ? '-' : '=';
                    break;
                case 0x2B:
                case 0x22 ... 0x24:
                case 0x2A:
                case 0x2C:
                    ch = p==1 ? '|' : '!';
                    break;
                case 0x38:
                case 0x39:
                case 0x3A:
                case 0x3B:
                    ch = Ascii_Guts;
                    break;
            }
            
            // no ladders, spikes
            
            s.ascii[y*32+x] = ch;
            s.ascii[y*32+x+16] = ' ';
            //printf("%02X",c);
        }
}

#define Wily3Char  DummyChar

static Level Wily3 =
{
    8, // level number.
    "Wily3",

    // screens:
    {
        {
        "################"
        "################"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "...............#"
        "################"
        "################"
        "################"
        "################"
        "################"
        "################"
        ,End},
        {"",Last}
    },

    // actives
    {
    },

    // enemies
    {
    },
    
    // palette
    {
        0x0F, 0x20, 0x00, 0x02, 
        0x0F, 0x2B, 0x19, 0x2C, 
        0x0F, 0x17, 0x07, 0x0F, 
        0x0F, 0x20, 0x00, 0x26, 
        
        0x0F, 0x2C, 0x11, 0x0F, 
        0x0F, 0x20, 0x38, 0x0F, 
        0x0F, 0x27, 0x15, 0x0F, 
        0x0F, 0x30, 0x11, 0x0F, 
        
        0x0F, 0x20, 0x00, 0x02, 
        0x0F, 0x00, 0x10, 0x20, 
        0x0F, 0x17, 0x07, 0x07, 
        0x0F, 0x20, 0x00, 0x26, 
    },

    Wily3Ascii,
    Wily3Char
};
