/*

ti pa

48.03 {49.03} 4A.03
50.03 {51.03} 52.03 = inside block type 1

4B.00 {4C.00} 4D.00
53.00 {54.00} 55.00 = inside block type 2

6F.00 = vertical block

64.01 65.01
6C.01 6D.01 = gutsman decoration

4E.03 = inside floor

38.00 39.00
3A.00 3B.00 = gutsblock

17.02 = inside background
16.02 = inside shadow

C5.00 = ladder

3E.00 {3C.00} = lift path
3D.00 = hole in lift path

63.01 69.01
68.01 6A.01 = teleporter

06.00 = last room door
62.00 = last room floor 

00.00 = black background
00.01 = wily palette 1
00.02 = wily palette 2

AE.00 = spike up (black bg)

*/
static void Wily4Ascii(Screen& s)
{
    for(unsigned y=0; y<16; ++y)
        for(unsigned x=0; x<16; ++x)
        {
            unsigned char c = s.outmap[y*16+x].tile;
            unsigned char p = s.outmap[y*16+x].palette;
            
            char ch = '?';
            /* Classify types.
             *
             *
             *
             */
            switch(c)
            {
                // air:
                case 0x00:
                    if(p == 1) { ch = '1'; break; }
                    if(p == 2) { ch = '2'; break; }
                    ch = '.';
                    break;
                
                case 0x16:
                case 0x17: // inside
                    ch = ' ';
                    break;
              
                case 0x48 ... 0x4A:
                case 0x50 ... 0x52: // block 1
                case 0x4B ... 0x4D:
                case 0x53 ... 0x55: // block 2
                case 0x6F: // vertical block
                case 0x4E: // floor in
                case 0x64: case 0x65:
                case 0x6C: case 0x6D: // gutsman decoration
                    ch = '#';
                    break;

                case 0xAE: //up spike
                case 0xBF: //down spike
                    ch = Ascii_Spike;
                    break;
                
                case 0xC5:
                    ch = Ascii_Ladder;
                    break;
                
                case 0x3E:
                    ch = '<';
                    break;
                case 0x3C:
                    ch = '-';
                    break;
                case 0x3D:
                    ch = '/';
                    break;
                    
                case 0x38:
                case 0x39:
                case 0x3A:
                case 0x3B:
                    ch = Ascii_Guts;
                    break;
                
                case 0x63: case 0x69: // tele top
                    ch = '_';
                    break;
                case 0x68: case 0x6A: // tele bottom
                    ch = '=';
                    break;
                    
                case 0x06:
                    ch = Ascii_WilyDoor;
                    break;
                
                case 0x62:
                    ch = 'W';
                    break;
            }
            
            s.ascii[y*32+x] = ch;
            s.ascii[y*32+x+16] = ' ';
            //printf("%02X",c);
        }
}

#define Wily4Char  DummyChar

static Level Wily4 =
{
    9, // level number,
    "Wily4",

    // screens:
    {
    },

    // actives
    {
    },

    // enemies
    {
    },
    
    // palette
    {
        0x0F, 0x20, 0x00, 0x02, 
        0x0F, 0x2B, 0x19, 0x2C, 
        0x0F, 0x17, 0x07, 0x0F, 
        0x0F, 0x20, 0x00, 0x26, 
        
        0x0F, 0x2C, 0x11, 0x0F, 
        0x0F, 0x20, 0x38, 0x0F, 
        0x0F, 0x27, 0x15, 0x0F, 
        0x0F, 0x30, 0x11, 0x0F, 
        
        0x0F, 0x20, 0x00, 0x02, 
        0x0F, 0x00, 0x10, 0x20, 
        0x0F, 0x17, 0x07, 0x07, 
        0x0F, 0x20, 0x00, 0x26, 
    },

    Wily4Ascii,
    Wily4Char
};
